<style>
.header_nav ul li.list_dw_nav a{
    padding-right: 0px;
}
.list_dw_nav{
    padding-right: 24px;
}
.list_dw_nav .dw_nav_list .dw_nav_child{
    min-width: auto;
    white-space: nowrap;
}
.list_dw_nav .dw_nav_list{
    width: auto;
    left: 9px;
}
</style>
<template>
	<nav class="header_nav">
        <div class="header_nav_ct">
            <router-link class="logo" :to="{name: 'monitor_view'}"></router-link>
            <div class="hd_actions">
                <!-- <a class="lang_icon" href="http://www.eosforce.io/" v-bind:href="get_portal_href()" target="_blank">{{ lang.portal }}</a> -->

                <div class="dw_nav_item">
                    <div class="dw_nav_item_tt">
                        <a href="javascript:;" class="lang_icon" target="_blank" v-for="item in langs" v-if="item.selected">{{ item.text  }}</a>
                        <span class="nav_dw_arrow"></span>
                    </div>
                    <div class="dw_nav_list">
                        <a class="dw_nav_child" v-for="item in langs" v-bind:class="{'dw_nav_selected': item.selected}"  target="_blank" @click="exchange(item)">{{ item.text }}</a>
                    </div>
                </div>

            </div>
            <ul>
                <template v-for="item in routers" >
                <li class="dw_nav_item list_dw_nav" v-if="Array.isArray(item)">
                    <div class="dw_nav_item_tt">
                        <a href="javascript:;" class="lang_icon" target="_blank" v-for="cate in item" v-if="cate.is_select">{{ cate.name  }}</a>
                        <span class="nav_dw_arrow"></span>
                    </div>
                    <div class="dw_nav_list" v-bind:style="show_down_nav_style" @click="hide_500m(item)">
                        <router-link class="dw_nav_child" :to="{name: cate.router_name}" v-for="cate in item" v-bind:class="{'dw_nav_selected': cate.is_select}" >
                            {{ cate.name }}
                        </router-link> 
                    </div>
                </li>
                <li v-if="!Array.isArray(item)">
                    <router-link :to="{name: item.router_name}" v-bind:class="{'nav_focus': item.is_select}">{{ item.name }}</router-link>
                </li>
                </template>
            </ul>
        </div>
        <mobile_nav v-bind:params="routers" v-bind:exchang_lang="exchange_lang" v-on:exchange_lang="exchange"></mobile_nav>
    </nav>
</template>
<script>
import '../../assets/css/index.css'
import '../../assets/css/fadeload.css'
import '../../assets/css/mobile.css'
import '../../assets/image/web/favicon.ico'
import { lang, set_lang } from '../../data/lang.js'
import mobile_nav from './mobile_nav.vue'
import {
    wait_time
} from '../utils/utils'
export default {
    data () {
        return {
            exchange_lang: lang.exchange_lang,
            lang: lang.data,
            langs: lang.langs,
            router_name: null,
            routers: [
                {
                    router_name: 'monitor_view',
                    name: lang.data.monitor,
                    is_select: false
                },
                [
                    {
                        router_name: 'block_view',
                        name: lang.data.blocks,
                        is_select: false
                    },
                    {
                        router_name: 'transaction_view',
                        name: lang.data.transactions,
                        is_select: false
                    },
                    {
                        router_name: 'accounts_view',
                        name: lang.data.accounts,
                        is_select: false
                    },
                    {
                        router_name: 'contract_account_list',
                        name: lang.data.contract_name,
                        is_select: false
                    },
                    // {
                    //     router_name: 'account_token_list',
                    //     name: lang.data.account_token,
                    //     is_select: false
                    // }              
                ],
                {
                    router_name: 'web_wallet_view',
                    name: lang.data.web_wallet_view,
                    is_select: false
                },
                // {
                //     router_name: 'eth_eos_mapping',
                //     name: lang.data.map_search,
                //     is_select: false
                // }
            ],
            show_cate_nav: false,
            show_down_nav_style: {
                display: ''
            }
        }
    },
    components: {
        mobile_nav
    },
    mounted () {
        this.init_router_name();
    },
    watch: {
        '$route.name' () {
            this.init_router_name();
        }
    },
    methods: {
        init_router_name () {
            let router_name = this.$route.name;
            let first_nav_item = null, choosed_item = null;
            for(let nav_item of this.routers){
                if(Array.isArray(nav_item)){
                    nav_item.map(item => {
                        if(item.router_name == router_name){
                            item.is_select = true;
                            choosed_item = item;
                        }else{
                            item.is_select = false;
                        }
                        first_nav_item = !first_nav_item ? item : first_nav_item;
                    });
                }else{
                    if(nav_item.router_name == router_name){
                        nav_item.is_select = true;
                    }else{
                        nav_item.is_select = false;
                    }
                }
            }

            if(!choosed_item && !first_nav_item.is_select){
                first_nav_item.is_select = true;
            }
        },
        async hide_500m () {
            this.show_down_nav_style.display = 'none';
            await wait_time(0.1);
            this.show_down_nav_style.display = '';
        },
        get_portal_href () {
            return 'https://eosforce.io//?lang=' + lang.now_lang.key;
        },
        exchange (item) {
            let key = item.key || item.router_name;
            let new_url = window.location.href.replace(`#/${lang.now_lang.key}`, `#/${key}`);
            window.location.href = new_url;
            set_lang(this.exchange_lang.key, () => {
                window.location.reload(true);
            });
        }
    }  
}
</script>